\ProvidesPackage{lstrtfiacre}
\RequirePackage{listings}
\RequirePackage{tabularx}

\lstdefinestyle{trans}{
	aboveskip=-\medskipamount,
	belowskip=-\medskipamount
}

\lstdefinelanguage{fiacre}%
	{keywords={
		and, any, append, array, bool, case, channel, component, const, dequeue,
		do, else, elsif, empty, end, enqueue, false, first, foreach, from, full,
		if, in, int, init, is, loop, nat, none, null, of, on, or, out, par,
		port,
		priority, process, queue, read, record, self, states, then, to, true,
		type, union, unless, var, wait, where, while, write, default, select
	}, sensitive=true,comment=[s]{/*}{*/},
	basicstyle=\footnotesize,
	keywordstyle=\color{blue},
	commentstyle=\color{gray}}

\lstdefinelanguage{rtfiacre}[]{fiacre}%
	{morekeywords={
		all, constr0, constr1, exists, SORTED_WAIT, WAIT
	}}

\lstnewenvironment{fiacre}{\lstset{language=fiacre}}{}
\lstnewenvironment{rtfiacre}{\lstset{language=rtfiacre}}{}

\newcommand{\trans}[2]{%
	\renewcommand{\tablename}{\textsc{Listing}}
	\begin{table}[htb!]
		\begin{tabularx}{\textwidth}{X|X}
			\lstinputlisting[style=trans,language=rtfiacre]
			{code/#1.rtfcr}
			&
			\lstinputlisting[style=trans,language=fiacre]
			{code/#1.fcr}
		\end{tabularx}
		\caption{#2}
		\label{lst:#1}
	\end{table}
}
